kubernetes cluster

### Control Plane Components

- control plane : manage the overall state of the cluster
  kube-api server:  The core component server that exposes kubernetes HTTP API
  etcd: Consistent and highly-avaliable key value store for all API server data
  kube-scheduler: looks for pods not yet bound to a node, and assigns each pod to a suitable node.
- kube-controller-manager: Runs controllers to implement kubernetes API behavior.
  cloud-controller-manager: integrates with underlying cloud providers. (optional)

### Node Components

- kubelet: Ensures that pods are running, including their containers.
- kube-proxy: Mantains network rules on nodes to implement services. (optional)
- container runtime: Software responsible for running containers.

### Add Ons

- DNS: For cluster wide DNS resolution
-  web UI(dashboard): For cluster management via web interface.
- Container resource monitoring: For collecting and storing container metrics.
- cluster-level logging: For saving container logs to a central log store.